/**
 * Created by SOFTlab 7.2017
**/

import controlP5.*;
import oscP5.*;
import netP5.*;
import ddf.minim.*;

import processing.serial.*;

byte[] led = new byte[9000];

ArrayList<Serial> ports = new ArrayList<Serial>();
 
Minim minim;
AudioInput sound;

float hvalue;
float svalue;

ControlP5 cp5;

OscP5 osc0;
OscP5 osc1;

OscP5 oscP5;
NetAddress myRemoteLocation;

ArrayList <PVector> people = new ArrayList<PVector>();
ArrayList <PVector> speed = new ArrayList<PVector>();
FloatList movec = new FloatList();

int agent_num = 10;

int firstValue;
int SecValue;
ArrayList<ArrayList<Integer>> track = new ArrayList<ArrayList<Integer>>();
ArrayList<Integer> ssc = new ArrayList<Integer>();

int limit;
int hcheck = 0;

float amplitude;
float threshold;

int CD = 0;
int ccd = 0;

boolean pulse = true;
boolean Random = true;
boolean Ambient = false;
boolean mouse_track = false;
boolean show_angles = false;
boolean wave = false;
boolean monitor = false;
boolean boxx = false;

boolean kinect_track = false;
boolean ksound = false;
boolean degree90 = false;

float dist = 40000;
float pd = 0;
FloatList pdist = new FloatList();
FloatList px = new FloatList();
FloatList py = new FloatList();
float pulsex = 0;
float pulsey = 0;
float pulse_speed = 3;
float pulse_width = 10;
float pulse_delay = 5;
int rannum = 5;

int rthreshold;
int randelay;

float decay;

int kinect = 0;
boolean display_kinect = true;
boolean display_tent = true;
boolean fill_mirrors = true;
int xk = 0;
int yk = 0;

int wcount = 0;
int w2count = 0;
int wspeed;

int mcount = 0;
int m2count = 0;
int mspeed;

int bcount = 0;
int b2count = 0;
int bspeed;

float xpos = 0;
float ypos = 0;

int xsize = 10;
int ysize = 10;
int space = 8;

int oldx = mouseX;
int oldy = mouseY;
float rotx = 0;
float roty = 0;
float zcam = 0;

int ptstart = 0;
int ptend = 0;

int xx = 0;
int yy = 0;

boolean angle_test = false;
int xmirror;
int ymirror;

int aatest;

boolean run = false;


int[] xp = {-90,-85,50,60,89,90,90,-83,82,50};
int[] yp = {-90,85,-90,82,70,83,90,40,40,89};


                     
int[][] k_rect = {  {-140,-31,48,-168},
                    {-49,-31,140,-168},
                    {-140, 69, 49,-69},
                    {-49, 69, 140,-69},
                    {-140,168,49,31}, 
                    {-48,168,140,31}};

float[][] angle = new float[xsize][ysize];
float[][] cangle = new float[xsize][ysize];

float[][] anglemult = new float[xsize][ysize];

float[][] oldangle = new float[xsize][ysize];
int[][] multiple = new int[xsize][ysize];

ArrayList<PVector> kinect_geo = new ArrayList<PVector>();
ArrayList<PVector> tent_geo = new ArrayList<PVector>();
ArrayList<PVector> mod_center = new ArrayList<PVector>();

ArrayList<PVector> trackpts = new ArrayList<PVector>();

IntList lights = new IntList();

void setup() {
  size(1700, 1000, P3D);
  perspective(PI/3.0,(float)width/height,1,100000);
  //fullScreen(P3D);
  
  oscP5 = new OscP5(this,6880);
  myRemoteLocation = new NetAddress("localhost",12000);
  
  
  for(int i = 0; i < 10; i++){
    people.add(new PVector(xp[i],yp[i],0));
    float mx = random(-1,1);
    float my = random(-1,1);
    speed.add(new PVector(mx,my,0));
    movec.append(0);
  }
  
  
  ptstart = 0;
  ptend = 0;
  /*
  ports.add(new Serial(this,"COM17",57600));
  ports.add(new Serial(this,"COM16",57600));
  ports.add(new Serial(this,"COM15",57600));
  ports.add(new Serial(this,"COM8",57600));
  ports.add(new Serial(this,"COM10",57600));
  ports.add(new Serial(this,"COM7",57600));
  ports.add(new Serial(this,"COM9",57600));
  ports.add(new Serial(this,"COM6",57600));
  ports.add(new Serial(this,"COM13",57600));
  ports.add(new Serial(this,"COM4",57600));
  */
  
  
  minim = new Minim(this);
  sound = minim.getLineIn(Minim.STEREO, 1024);
  
  
  
  for(int i = 0; i < xsize; i++){
    for(int j = 0; j < ysize; j++){
      multiple[i][j] = 1;
    }
  }
  
  String[] coor = loadStrings("kinect.txt");
  for(int i = 0; i < (coor.length/3); ++i){
    float xx = float(coor[i*3]);
    float yy = float(coor[i*3+1])*-1;
    float zz = float(coor[i*3+2]);
    kinect_geo.add(new PVector(xx,yy,zz));
  }
  coor = loadStrings("tent.txt");
  for(int i = 0; i < (coor.length/3); ++i){
    float xx = float(coor[i*3]);
    float yy = float(coor[i*3+1])*-1;
    float zz = float(coor[i*3+2]);
    tent_geo.add(new PVector(xx,yy,zz));
  }
  coor = loadStrings("mirrors.txt");
  for(int i = 0; i < (coor.length/3); ++i){
    float xx = float(coor[i*3]);
    float yy = float(coor[i*3+1])*-1;
    float zz = float(coor[i*3+2]);
    mod_center.add(new PVector(xx,yy,zz));
    lights.append(1);
  }
  
  cp5 = new ControlP5(this);
  
  cp5.addSlider("agent_num")
     .setPosition(40,40)
     .setRange(0,10)
     .setSize(240,20)
     .setValue(5)
     .setNumberOfTickMarks(11)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
    ;
    
  cp5.addToggle("display_kinect")
     .setPosition(340,40)
     .setSize(20,20)
     .setColorForeground(color(20,20,20))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(0xffff88ff)
     .setColorActive(color(0,200,200))
     ;
   
   cp5.addToggle("mouse_track")
     .setPosition(340,80)
     .setSize(20,20)
     .setColorForeground(color(20,20,20))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(0xffff88ff)
     .setColorActive(color(0,200,200))
     ;
     
   cp5.addToggle("kinect_track")
     .setPosition(340,170)
     .setSize(20,20)
     .setColorForeground(color(20,20,20))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(0xffff88ff)
     .setColorActive(color(0,200,200))
     ;
     
   cp5.addToggle("ksound")
     .setPosition(340,210)
     .setSize(20,20)
     .setColorForeground(color(20,20,20))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(0xffff88ff)
     .setColorActive(color(0,200,200))
     ;
     
    cp5.addToggle("degree90")
     .setPosition(340,130)
     .setSize(20,20)
     .setColorForeground(color(20,20,20))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(0xffff88ff)
     .setColorActive(color(0,200,200))
     ;
     
   cp5.addToggle("run")
     .setPosition(420,170)
     .setSize(20,20)
     .setColorForeground(color(20,20,20))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(0xffff88ff)
     .setColorActive(color(0,200,200))
     ;
     
   cp5.addToggle("show_angles")
     .setPosition(420,130)
     .setSize(20,20)
     .setColorForeground(color(20,20,20))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(0xffff88ff)
     .setColorActive(color(0,200,200))
     ;
     
   cp5.addToggle("display_tent")
     .setPosition(420,40)
     .setSize(20,20)
     .setColorForeground(color(20,20,20))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(0xffff88ff)
     .setColorActive(color(0,200,200))
     ;
     
     
   cp5.addToggle("fill_mirrors")
     .setPosition(420,80)
     .setSize(20,20)
     .setColorForeground(color(20,20,20))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(0xffff88ff)
     .setColorActive(color(0,200,200))
     ;
     
     cp5.addSlider("amplitude")
    .setPosition(40,80)
    .setRange(0,200)
    .setSize(200,20)
    .setValue(200)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("threshold")
    .setPosition(40,110)
    .setRange(0,200)
    .setSize(200,20)
    .setValue(100)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
     
      
      cp5.addButton("Pers")
     .setValue(0)
     .setPosition(140,140)
     .setSize(80,20)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
     
      cp5.addButton("Countdown")
     .setValue(0)
     .setPosition(140,210)
     .setSize(80,20)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
     /*
     cp5.addToggle("angle_test")
     .setPosition(140,240)
     .setSize(20,20)
     .setValue(false)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
     
     cp5.addSlider("xmirror")
    .setPosition(140,280)
    .setRange(0,9)
    .setSize(200,20)
    .setValue(0)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("ymirror")
    .setPosition(140,310)
    .setRange(0,9)
    .setSize(200,20)
    .setValue(0)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("aatest")
    .setPosition(140,340)
    .setRange(0,360)
    .setSize(200,20)
    .setValue(0)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
     */
     cp5.addButton("Home")
     .setValue(0)
     .setPosition(140,170)
     .setSize(80,20)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
     
     cp5.addButton("ResetView")
     .setValue(0)
     .setPosition(40,140)
     .setSize(80,20)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
    
     
     cp5.addButton("ResetTrack")
     .setValue(0)
     .setPosition(40,170)
     .setSize(80,20)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
     
  
     cp5.addToggle("pulse")
     .setPosition(520,40)
     .setSize(20,20)
     .setValue(true)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
   
   cp5.addSlider("pulse_speed")
    .setPosition(560,40)
    .setRange(0,10)
    .setSize(200,20)
    .setValue(5)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("pulse_width")
    .setPosition(560,80)
    .setRange(0,10)
    .setSize(200,20)
    .setValue(5)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("pulse_delay")
    .setPosition(560,110)
    .setRange(0,200)
    .setSize(200,20)
    .setValue(28)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("decay")
    .setPosition(560,140)
    .setRange(0,3)
    .setSize(200,20)
    .setValue(0.5)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;

     cp5.addToggle("Random")
     .setPosition(850,40)
     .setSize(20,20)
     .setValue(true)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
   
   cp5.addSlider("rannum")
    .setPosition(890,40)
    .setRange(0,100)
    .setSize(200,20)
    .setValue(1)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("randelay")
    .setPosition(890,70)
    .setRange(0,30)
    .setSize(200,20)
    .setValue(3)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addSlider("rthreshold")
    .setPosition(890,100)
    .setRange(0,200)
    .setSize(200,20)
    .setValue(5)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  
   cp5.addToggle("wave")
     .setPosition(1150,40)
     .setSize(20,20)
     .setValue(false)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
   
   cp5.addSlider("wspeed")
    .setPosition(1190,40)
    .setRange(0,100)
    .setSize(200,20)
    .setValue(5)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
   cp5.addToggle("monitor")
     .setPosition(1150,80)
     .setSize(20,20)
     .setValue(false)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
   
   cp5.addSlider("mspeed")
    .setPosition(1190,80)
    .setRange(0,100)
    .setSize(200,20)
    .setValue(5)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
  
  cp5.addToggle("boxx")
     .setPosition(1150,120)
     .setSize(20,20)
     .setValue(false)
     .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
     ;
     
   cp5.addSlider("bspeed")
    .setPosition(1190,120)
    .setRange(0,100)
    .setSize(200,20)
    .setValue(5)
    .setColorForeground(color(20,200,200))
     .setColorLabel(color(255))
     .setColorBackground(color(70,70,70))
     .setColorValue(color(0,0,0))
     .setColorActive(color(0,255,255))
  ;
     
     for (int i=0; i < 6; i++) {
       track.add(new ArrayList<Integer>());
     } 
     
     for (int i=0; i < 6; i++) {
       ssc.add(0);
     } 
}


void draw() {
  background(0);
  xpos = mouseX-width/2;
  ypos = mouseY-height/2;
  
  hvalue = 0;
  for(int i = 0; i < sound.mix.size() - 1; i++){
    //line(i, 700 + sound.mix.get(i)*amplitude, i+1, 700 + sound.mix.get(i+1)*amplitude);
    if(hvalue <  abs(sound.mix.get(i))){
      hvalue = abs(sound.mix.get(i));
    }
  }
  
  hvalue = hvalue * amplitude;
  
  svalue = 0;
  
  for(int i = 0; i < ssc.size() - 1; i++){
    if(svalue <  abs(ssc.get(i))){
      svalue = abs(ssc.get(i));
    }
  }
  
  svalue = svalue * amplitude/100;
  
  if(ksound == true){
    hvalue = svalue;
  }

  ////sound bar////
  noStroke();
  rectMode(CORNER);
  fill(70);
  rect(40,200,50,200);
  fill(20,200,200);
  rect(40,400,50,(hvalue*-1));
  
  stroke(255);
  line(100,(400-threshold),110,(400-threshold));
  line(120,(400-rthreshold),130,(400-rthreshold));
  pushMatrix();
  cam();
  
  
  trackpts = new ArrayList<PVector>();
  
  for(int i = 0; i < 10; i++){
    PVector center = people.get(i);
    PVector s = speed.get(i);
    if(i < agent_num){
      fill(239,20,67);
      noStroke();
      ellipse(center.x,center.y,10,10);
      stroke(255);
      strokeWeight(1);
      line(center.x-2,center.y,center.x+2,center.y);
      line(center.x,center.y-2,center.x,center.y+2);
      stroke(239,20,67);
      line(center.x,center.y,10,center.x,center.y,60);
      trackpts.add(new PVector(center.x,center.y,0));
    }
    float newx = center.x + s.x;
    float newy = center.y + s.y;
    if((abs(newx) > 100 && (abs(newy) > 80)) || ((abs(newy) < 80) && ((abs(newx) < 80) || (abs(newx) > 100)))){
      speed.set(i,new PVector(-s.x,s.y,0));
      newx = center.x - s.x;
    }
    if((abs(newy) > 100 && (abs(newx) > 80)) || ((abs(newx) < 80) && ((abs(newy) < 80) || (abs(newy) > 100)))){
      speed.set(i,new PVector(s.x,-s.y,0));
      newy = center.y - s.y;
    }
    
    people.set(i,new PVector(newx,newy,0));
    
    
    
    movec.set(i,movec.get(i)-1);

    if(movec.get(i) < 0){
      movec.set(i,random(50)+15);
      float mx = random(-0.2,0.2);
      float my = random(-0.2,0.2);
      speed.set(i,new PVector(mx,my,0));
    }
  }
  
  
  noFill();
  
  float nx = 0;
  float ny = 0;
  
  if(mouse_track == true){
    ArrayList<Integer> t = new ArrayList<Integer>();
    t.add(mouseX);
    t.add(mouseY);
    //t.add(600);
    //t.add(600);
    //t.add(1100);
    //t.add(500);
    track.set(0,t);
  }



    for(int i = 0; i < track.size(); i++){
      for(int j = 0; j < track.get(i).size(); j++){
         xx = track.get(i).get(j);
         j++;
         yy = 424 - track.get(i).get(j);
         if(mouse_track == false){
             if(kinect_track == true){
               nx = k_rect[i][0] + (k_rect[i][2] - k_rect[i][0]) * xx/512;
               ny = k_rect[i][1] + (k_rect[i][3] - k_rect[i][1]) * yy/424;
             }
           }else{
             nx = xx-width/2;
             ny = track.get(i).get(j)-height/2;
           }
         fill(0,255,255);
         noStroke();
         if(mouse_track == true || kinect_track == true ){
         ellipse(nx,ny,10,10);
         trackpts.add(new PVector(nx,ny,0));
         }
      }
    }

  

  
  for(int i = 0; i < (trackpts.size()); i++){
      PVector vs =  trackpts.get(i);
      fill(0,255,255);
      //ellipse(vs.x,vs.y,10,10);
    }
    
  
  
 
  
  if(display_tent == true){
    stroke(255,50);
    strokeWeight(1);
    for(int i = 0; i < (tent_geo.size()); ++i){
      PVector vs =  tent_geo.get(i);
      PVector ve =  tent_geo.get(i+1);
      noFill();
      line(vs.x, vs.y, vs.z, ve.x, ve.y, ve.z);
      i++;
    }
  }
  
  
  if(display_kinect == true){
    
    strokeWeight(1);
    stroke(0,255,255);
    for(int i = 0; i < (kinect_geo.size()); ++i){
      PVector vs =  kinect_geo.get(i);
      PVector ve =  kinect_geo.get(i+1);
      noFill();
      line(vs.x, vs.y, vs.z, ve.x, ve.y, ve.z);
      i++;
    }
  
    noStroke();
 
    for(int i = 0; i < 6; ++i){
        if(kinect == i){
          fill(255);
          textSize(20);
          text(i,k_rect[i][0]+(k_rect[i][2] - k_rect[i][0])/2,k_rect[i][1] + (k_rect[i][3] - k_rect[i][1])/2);
          
          fill(255,50);
        }else{
          noFill();
        }
        rect(k_rect[i][0],k_rect[i][1], k_rect[i][2] - k_rect[i][0], k_rect[i][3] - k_rect[i][1]);
   
    }
  }
  

  PVector vs =  mod_center.get(0);
  float newx = vs.x;
  float newy = vs.y;
  PVector vp;
  float l = 0;
  float h = 0;
  if(trackpts.size() > 0){
    vp =  trackpts.get(0);
    l = 1/dist(vs.x,vs.y,vp.x,vp.y);
    h = 1/dist(vs.x,vs.y,vp.x,vp.y);
  }
  
  for(int i = 0; i < mod_center.size(); i++){
    vs =  mod_center.get(i);
    for(int j = 0; j < trackpts.size(); j++){
      vp =  trackpts.get(j);
      float d = 1/dist(vs.x,vs.y,vp.x,vp.y);
      if(d < l){
          l = d;
        }
        if(d > h){
          h = d;
        }
    }
  }
 
  
  
  int c = 0;
  for(int i = 0; i < xsize; i++){
    for(int j = 0; j < ysize; j++){
      vs =  mod_center.get(c);
      newx = vs.x;
      newy = vs.y;
      float dv = 0;
      float tx = 0;
      float ty = 0;
      float na = 0;
      for(int ac = 0; ac < trackpts.size(); ac++){
        vp =  trackpts.get(ac);
        float d = 1/dist(vs.x,vs.y,vp.x,vp.y);
        float rd = map(d,l,h,0.0001,1.0);


        tx = tx + vp.x*rd*rd;
        ty = ty + vp.y*rd*rd;
        dv = dv + rd*rd;
      }
      
      /*
      if(tx == 0 && dv == 0){
        tx = 0;
      }else{
        tx = tx/dv;
      }
      if(ty == 0 && dv == 0){
        ty = 0;
      }else{
        ty = ty/dv;
      }
      */
      
      tx = tx/dv;
      ty = ty/dv;
  
      stroke(0,255,255,80);
      line(newx,newy,tx,ty);
      
      if(trackpts.size() > 0){
        na = -atan2(tx-newx, ty-newy);
      }
      if(na < 0){
        na = 2 * PI + na;
      }
      angle[i][j] = na;
      
      
      if(angle_test == true){
        if(i == xmirror && j == ymirror){
          angle[i][j] = radians(aatest);
        }else{
          angle[i][j] = 0;
        }
      }
      
      if(degree90 == true){
          angle[i][j] = PI * 0.5;
        }
        
        
      if(abs(cangle[i][j] - angle[i][j]) < PI){
        if(cangle[i][j] < angle[i][j]){
         cangle[i][j] = cangle[i][j] + 0.05;
        }else{
         cangle[i][j] = cangle[i][j] - 0.05;
        }
      }
      
      if(abs(cangle[i][j] - angle[i][j]) >= PI){
        if(cangle[i][j] < angle[i][j]){
         cangle[i][j] = cangle[i][j] - 0.05;
        }else{
         cangle[i][j] = cangle[i][j] + 0.05;
        }
      }
      
      if(abs(cangle[i][j] - angle[i][j]) < 0.06){
         cangle[i][j] = angle[i][j];
       }
      
      if(cangle[i][j] >= 2*PI){
        cangle[i][j] = 0;
      }
      if(cangle[i][j] < 0){
        cangle[i][j] = 2*PI;
      }
      
      if(i == 6 && j == 3){
       //println(degrees(cangle[i][j])); 
      }    
      
      
      if(abs(na-oldangle[i][j]) > 1){
        if(na < oldangle[i][j]){
          multiple[i][j]++;
          println(multiple[i][j]);
        }else{
          multiple[i][j]--;
        }
      }
      oldangle[i][j] = na;
      
      na = angle[i][j] + multiple[i][j]*PI*2;
      
      
      anglemult[i][j] = na;
       
      na = cangle[i][j] + multiple[i][j]*PI*2;
 
      pushMatrix();
      translate(newx,newy);
      rotate(na);
      strokeWeight(2);
      stroke(255);
      line(-space/2,0,space/2,0);
      popMatrix();
      strokeWeight(1);
      line(newx,newy,0,newx,newy,20);
      pushMatrix();
      translate(newx,newy,40);
      rotateZ(na);
      stroke(100);
      strokeWeight(1);
      if(fill_mirrors == true){
        fill(50,50,50,150);
      }else{
        noFill();
      }
      box(9,1.5,40);
      stroke(0,255,255);
      strokeWeight(2);
      
      if(Random == true){
          float ch = random(0,100);
          if(frameCount%randelay == 0){
            if(ch < rannum && hvalue > rthreshold){
              lights.set(c,30);
            }
          }
      }
      
      if(pulse == true){
          for(int pp = 0; pp < pdist.size(); pp++){
            float dd = dist(px.get(pp),py.get(pp),newx,newy);
            if(abs(pdist.get(pp) - dd) < pulse_width){
              lights.set(c,30);
            }
        
          }
      }
      
      if(wave == true){
          if(i == wcount){
            lights.set(c,int(hvalue/6.666));
          }
      }
      
      if(monitor == true){
          if(i == mcount){
            int vol = int(hvalue/40);
            if((j < 4 + vol) && (j > 4-vol)){
              lights.set(c,30);
            }
          }
      }
      
      
      if(boxx == true){
        if(hvalue > threshold){
          bcount = 0;
        }
        //println(bcount);
          if((5 + bcount == i) && (j<5+bcount) && (j>5-bcount)){
              lights.set(c,30);
          }
          if((5 - bcount == i) && (j<5+bcount)&& (j>5-bcount)){
              lights.set(c,30);
          }
          if((5 + bcount == j) && (i<5+bcount) && (i>5-bcount)){
              lights.set(c,30);
          }
          if((5 - bcount == j) && (i<5+bcount)&& (i>5-bcount)){
              lights.set(c,30);
          }
      }
      
      
      if(c == CD){
        lights.set(c,30);
        angle[i][j] = 180;
        
      }
      
      float lh = lights.get(c);
      if(lh > 1){
        lights.set(c,int(lh-decay));
      }else{
        lights.set(c,0);
      }
      line(-4.5,0,-20,-4.5,0,-20+lh*1.33);
      line(4.5,0,-20,4.5,0,-20+lh*1.33);
      popMatrix();
      c++;
    }
  }
  
  
  popMatrix();
  
 
  
  if( show_angles == true){
    for(int i = 0; i < xsize; i++){
      for(int j = 0; j < ysize; j++){
          fill(255);
          textSize(12);
          text(int(degrees(angle[i][j])), i * 40+15, j*40+600);
          pushMatrix();
          stroke(255,100);
          strokeWeight(1);
          translate(i * 40+27, j*40+615);
          rotate(cangle[i][j]);
          line(-10,0,10,0);
          
          popMatrix();
      }
    }
  }
  
  if(hvalue > threshold && pd > pulse_delay){
     dist = 0;
     px.append(random(-200,200));
     py.append(random(-200,200));
     pdist.append(0);
     pd = 0;
  }
  for(int pp = 0; pp < pdist.size(); pp++){
      pdist.set(pp,pdist.get(pp)+ pulse_speed);
      if(pdist.get(pp) > 3000){
          pdist.remove(pp);
          px.remove(pp);
          py.remove(pp);
      }
   }

   pd++;
   
   
   //////////////LEDS///////////////////////
   OscMessage myMessage = new OscMessage("/leds");
   c = 0;
   int lc = 0;
   for(int i = 0; i < xsize; i++){
    for(int j = 0; j < ysize; j++){
      int ln = lights.get(c);
      myMessage.add(ln);
      c++;
    }
   }
   oscP5.send(myMessage, myRemoteLocation);
   
  ////////////////flip///////////////// 
   
  float [][] mrot2 = new float[xsize][ysize];;
  
  for(int i = 0; i < xsize; i++){
      for(int j = 0; j < ysize; j++){
        mrot2[i][j] = angle[9-i][9-j];
      }
  }
  
  float [][] mrot3 = new float[xsize][ysize];;
  
  for(int i = 0; i < xsize; i++){
      for(int j = 0; j < ysize; j++){
        mrot3[i][j] = mrot2[i][9-j];
      }
  }
  
  
  if(run == true){
    if(frameCount%15 == 0){
      for(int i = ptstart; i < ptend; i++){
        float[] sendangle = new float[ysize];
        for(int j = 0; j < ysize; j++){
              //sendangle[j] = mrot[i][j]+ multiple[i][j]*PI*2;
              if(angle[i][j] == 180){
                //println("xxx" + angle[i][j]);
                }
              
              sendangle[j] = -mrot3[i][j] + PI *0.5;
        }
        Serial port = ports.get(i); 
        sendData(sendangle,port);
      }
    }
  }
  
  
  if(w2count > wspeed){
    w2count = 0;
    wcount++;
    if(wcount == 10){
      wcount = 0;
    }
  }
  
  w2count++;
  
  if(m2count > mspeed){
    m2count = 0;
    mcount++;
    if(mcount == 10){
      mcount = 0;
    }
  }
  
  m2count++;
  
  if(b2count > bspeed){
    b2count = 0;
    bcount++;
  }
  //println(bcount);
  b2count++;
 
  
  
  if(frameCount  % 15 == 0){
    CD++;
  }
  
}

void cam() {
  int newx = mouseX;
  int newy = mouseY;
  translate(width/2, height/2,zcam);
  rotateY(rotx);
  rotateX(roty);
  translate(0,0,-30);
  //rotateZ(PI);
  if ((mousePressed == true) && (mouseY < 700)&& (mouseY > 400)) {
    rotx = rotx + (oldx-newx)/50.0;
    roty = roty + (oldy-newy)/50.0;
  }

  
  oldx = newx;
  oldy = newy;
}

void mouseWheel(MouseEvent event) {
  float e = event.getCount();
  zcam = zcam - e*5;
}

/* incoming osc message are forwarded to the oscEvent method. */
void oscEvent(OscMessage theOscMessage) {
  /* print the address pattern and the typetag of the received OscMessage */
  if(mouse_track == false){
  if(theOscMessage.checkAddrPattern("/p0")==true) {
    /* check if the typetag is the right one. */
      ArrayList<Integer> t = new ArrayList<Integer>();
      /* parse theOscMessage and extract the values from the osc message arguments. */
      limit = theOscMessage.get(0).intValue();  // get the first osc argument
      ssc.set(4,theOscMessage.get(1).intValue());
      for(int i = 2; i < limit*2+1; i++){
        t.add(theOscMessage.get(i).intValue());
        i++;
        t.add(theOscMessage.get(i).intValue());
      }
      track.set(0,t);
   }
   
   if(theOscMessage.checkAddrPattern("/p1")==true) {
    /* check if the typetag is the right one. */
     ArrayList<Integer> t = new ArrayList<Integer>();
      /* parse theOscMessage and extract the values from the osc message arguments. */
      limit = theOscMessage.get(0).intValue();  // get the first osc argument
      ssc.set(4,theOscMessage.get(1).intValue());
      for(int i = 2; i < limit*2+1; i++){
        t.add(theOscMessage.get(i).intValue());
        i++;
        t.add(theOscMessage.get(i).intValue());
      }
      track.set(1,t);
   }
   
   if(theOscMessage.checkAddrPattern("/p2")==true) {
    /* check if the typetag is the right one. */
     ArrayList<Integer> t = new ArrayList<Integer>();
      /* parse theOscMessage and extract the values from the osc message arguments. */
      limit = theOscMessage.get(0).intValue();  // get the first osc argument
      ssc.set(4,theOscMessage.get(1).intValue());
      for(int i = 2; i < limit*2+1; i++){
        t.add(theOscMessage.get(i).intValue());
        i++;
        t.add(theOscMessage.get(i).intValue());
      }
      track.set(2,t);
   }
   
   if(theOscMessage.checkAddrPattern("/p3")==true) {
    /* check if the typetag is the right one. */
     ArrayList<Integer> t = new ArrayList<Integer>();
      /* parse theOscMessage and extract the values from the osc message arguments. */
      limit = theOscMessage.get(0).intValue();  // get the first osc argument
      ssc.set(4,theOscMessage.get(1).intValue());
      for(int i = 2; i < limit*2+1; i++){
        t.add(theOscMessage.get(i).intValue());
        i++;
        t.add(theOscMessage.get(i).intValue());
      }
      track.set(3,t);
   }
   
   if(theOscMessage.checkAddrPattern("/p4")==true) {
    /* check if the typetag is the right one. */
     ArrayList<Integer> t = new ArrayList<Integer>();
      /* parse theOscMessage and extract the values from the osc message arguments. */
      limit = theOscMessage.get(0).intValue();  // get the first osc argument
      ssc.set(4,theOscMessage.get(1).intValue());
      for(int i = 2; i < limit*2+1; i++){
        t.add(theOscMessage.get(i).intValue());
        i++;
        t.add(theOscMessage.get(i).intValue());
      }
      track.set(4,t);
   }
   
   if(theOscMessage.checkAddrPattern("/p5")==true) {
    /* check if the typetag is the right one. */
     ArrayList<Integer> t = new ArrayList<Integer>();
      /* parse theOscMessage and extract the values from the osc message arguments. */
      limit = theOscMessage.get(0).intValue();  // get the first osc argument
      ssc.set(4,theOscMessage.get(1).intValue());
      for(int i = 2; i < limit*2+1; i++){
        t.add(theOscMessage.get(i).intValue());
        i++;
        t.add(theOscMessage.get(i).intValue());
      }
      track.set(5,t);
   }
  }
      return;
  }

public void ResetView(){
  rotx = 0;
  roty = 0;
  zcam = 450;
}


public void Pers(){
  rotx = 0.6799999;
  roty = 1.5799999;
  zcam = 695;
}

public void Countdown(){
  if(ccd == 0){
    CD = 1000;
  }else{
    CD = 0;
  }
  ccd = 1;
}
  
 
public void ResetTrack(){
  track = new ArrayList<ArrayList<Integer>>();
  for (int i=0; i < 6; i++) {
       track.add(new ArrayList<Integer>());
     } 
}


public void sendData( float[] angles, Serial port){

  Serial sendport = port;
  int[] transferArray = new int[22]; 

  for (int i = 0; i < 10; i++) {               //loop through array of ten angles and create ramainder and multiple

    int plusNum = int(degrees(angles[i]))+5000; 
    int multiple = floor(plusNum /124);
    int remainder = plusNum  % 124;

    transferArray [i*2] = remainder;           //weave transfer array from temp values
    transferArray [(i*2)+1] = multiple;
  }

  int sum = 0;

  for (int n=0; n<20; n++) {                   //Summation 
    sum = sum + transferArray[n];
  }

  int multipleCheckSum = floor(sum /124);
  int remainderCheckSum = sum  % 124;

  transferArray[20] = remainderCheckSum;       //add on checksum to transfer array
  transferArray[21] = multipleCheckSum;

  // transferArray complete (begin trasnfer
  sendport.clear();     
  sendport.write(byte(126));                   //send start char
  for (int n=0; n<22; n++) {                   //loop through array
    sendport.write(transferArray[n]);
    //print(transferArray[n]);
    //print(",");
  }
  sendport.write(byte(125));                    //send end char
  //println(" sent");
}

public void Home() {
  byte[] homeArray = {3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 60, 0};
  if(hcheck > 0){
    for(int i = 0; i < ports.size(); i++){
      Serial sendport = ports.get(i);
    
      sendport.clear();     
      sendport.write(byte(126));             //send start char
      for (int n=0; n<22; n++) {             //loop through array
        sendport.write(homeArray[n]);
        //print(homeArray[n]);
        //print(",");
      }
      sendport.write(byte(125));             //send end char
      //println("sent");
    }
  }
  hcheck++;
  //angle_test = true;
}
